## fcitx 4.2.9.7-3mint1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)

project(fcitx)

set(version 4.2.9.7)

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED TRUE)

find_package(ECM 0.0.11 REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH "${ECM_MODULE_PATH}" "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
set(CMAKE_AUTOMOC_RELAXED_MODE TRUE)

set_property(GLOBAL PROPERTY "__FCITX_INTERNAL_BUILD" On)

option(ENABLE_X11 "Enable X11 as dependency" ON)
option(ENABLE_GLIB2 "Enable GLib2 as depenedency" ON)
option(ENABLE_CAIRO "Enable Cairo" ON)
option(ENABLE_DBUS "Enable DBus Support" ON)
option(ENABLE_PANGO "Enable Pango Support" ON)
option(ENABLE_XKB "Enable xkb support" ON)
option(ENABLE_DEBUG "Enable Debug" OFF)
option(ENABLE_PINYIN "Enable Pinyin" ON)
option(ENABLE_TABLE "Enable Table IM" ON)
option(ENABLE_GTK2_IM_MODULE "Enable GTK2 IM Module" ON)
option(ENABLE_GTK3_IM_MODULE "Enable GTK3 IM Module" OFF)
option(ENABLE_QT "Enable Qt-based lib" On)
option(ENABLE_QT_IM_MODULE "Enable Qt IM Module" ON)
option(ENABLE_QT_GUI "Enable Qt-based configuration GUI" On)
option(ENABLE_OPENCC "Enable OpenCC for Chinese Transform" ON)
option(FORCE_OPENCC
  "Enable opencc even if the library is not found at compile time" Off)
option(ENABLE_LUA "Enable Lua support" OFF)
option(ENABLE_STATIC "Build Static Library" OFF)
option(ENABLE_TEST "Test build" OFF)
option(ENABLE_SNOOPER "Enable Key Snooper for gtk app" On)
option(ENABLE_GIR "Enable GObject Introspection" On)
option(ENABLE_ENCHANT "Enable enchant for word predication" On)
option(ENABLE_PRESAGE "Enable presage for word predication" On)
option(FORCE_ENCHANT
  "Enable enchant even if the library is not found at compile time" Off)
option(FORCE_PRESAGE
  "Enable presage even if the library is not found at compile time" Off)
option(ENABLE_BACKTRACE "Enable backtrace support" On)
option(ENABLE_XDGAUTOSTART "Enable xdg autostart desktop file installation" On)
option(ENABLE_GETTEXT "Enable gettext support." On)
option(ENABLE_SPELL "Enable Spell Addon" On)

if(NOT NO_SNOOPER_APPS)
  set(NO_SNOOPER_APPS ".*chrome.*,.*chromium.*,firefox.*,Do.*"
    CACHE STRING "Disable Key Snooper for following app")
endif()

if(NOT NO_PREEDIT_APPS)
  set(NO_PREEDIT_APPS "gvim"
    CACHE STRING "Disable Preedit for the following apps")
endif()

include(CheckIncludeFiles)
include(CheckFunctionExists)
include(FindPkgConfig)
include(UseDoxygen OPTIONAL)
include(FcitxMacro)

_fcitx_add_uninstall_target()
check_include_files(unistd.h HAVE_UNISTD_H)
check_include_files(malloc.h HAVE_MALLOC_H)
check_include_files(stdbool.h HAVE_STDBOOL_H)
check_function_exists(asprintf HAVE_ASPRINTF)

find_package(Libintl REQUIRED)
find_package(Libiconv REQUIRED)
find_package(Pthread REQUIRED)
find_package(Libexecinfo)
find_package(GettextPo)
find_package(XKBCommon 0.5.0 REQUIRED COMPONENTS XKBCommon)

if(NOT ENABLE_GETTEXT OR NOT GETTEXTPO_FOUND)
  fcitx_disable_gettext()
endif()

if(LIBEXECINFO_LIB_FOUND)
  set(ENABLE_BACKTRACE 1)
else()
  set(ENABLE_BACKTRACE 0)
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "BSD")
  find_package(Libkvm REQUIRED)
endif(${CMAKE_SYSTEM_NAME} MATCHES "BSD")
find_package(DL REQUIRED)
if(ENABLE_ENCHANT)
  find_package(Enchant)
  if(NOT (ENCHANT_FOUND OR FORCE_ENCHANT))
    set(ENABLE_ENCHANT Off)
  endif()
endif()
if (ENABLE_XKB)
    # Parse xkb xml file
    find_package(LibXml2 REQUIRED)
    find_package(IsoCodes REQUIRED)
    find_package(XkbFile REQUIRED)
    # Parse isocodes json
    pkg_check_modules(JsonC "json-c" IMPORTED_TARGET REQUIRED)
endif (ENABLE_XKB)
if(ENABLE_PRESAGE)
  find_package(Presage)
  if(NOT (PRESAGE_FOUND OR FORCE_PRESAGE))
    set(ENABLE_PRESAGE Off)
  endif()
endif()

if(ENABLE_QT)
  find_package(Qt4 4.8 COMPONENTS QtCore QtGui QtDBus REQUIRED)
endif()

if(ENABLE_X11)
find_package(X11 REQUIRED)

if (NOT X11_Xkb_FOUND)
    message(FATAL_ERROR "Xkb is needed")
endif (NOT X11_Xkb_FOUND)

find_package(XKeyboardConfig REQUIRED)

endif()

if (ENABLE_TEST)
    enable_testing()
endif ()

set(_ENABLE_CAIRO 0)
set(_ENABLE_PANGO 0)
if (ENABLE_X11 AND ENABLE_CAIRO)
    PKG_CHECK_MODULES(CAIRO_XLIB REQUIRED "cairo-xlib>=1.0" )
    if (CAIRO_XLIB_FOUND)
        set(_ENABLE_CAIRO 1)
    endif (CAIRO_XLIB_FOUND)
endif (ENABLE_X11 AND ENABLE_CAIRO)

set(_ENABLE_PANGO 0)
if (_ENABLE_CAIRO AND ENABLE_GLIB2)
    if (ENABLE_PANGO)
        PKG_CHECK_MODULES(PANGOCAIRO "pangocairo>=1.0" )
        if (PANGOCAIRO_FOUND)
            set(_ENABLE_PANGO 1)
        endif (PANGOCAIRO_FOUND)
    endif (ENABLE_PANGO)
    if (NOT _ENABLE_PANGO)
        PKG_CHECK_MODULES(FONTCONFIG REQUIRED "fontconfig")
    endif (NOT _ENABLE_PANGO)
endif(_ENABLE_CAIRO AND ENABLE_GLIB2)

set(_ENABLE_DBUS 0)
if (ENABLE_DBUS)
    PKG_CHECK_MODULES(DBUS "dbus-1>=1.1.0" )
    if (DBUS_FOUND)
        set(_ENABLE_DBUS 1)
    endif (DBUS_FOUND)
endif (ENABLE_DBUS)

if(ENABLE_OPENCC)
    find_package(OpenCC)
    if(NOT (OPENCC_FOUND OR FORCE_OPENCC))
        set(ENABLE_OPENCC Off)
    endif()
endif()

set(HAVE_XINERAMA 0)
if (X11_Xinerama_FOUND)
    set(HAVE_XINERAMA 1)
endif (X11_Xinerama_FOUND)

if (X11_Xfixes_FOUND)
    set(HAVE_XFIXES 1)
endif (X11_Xfixes_FOUND)

if(ENABLE_DEBUG)
    set(_DEBUG ON)
endif(ENABLE_DEBUG)

set(package     fcitx)
set(prefix      ${CMAKE_INSTALL_PREFIX})
set(exec_prefix ${CMAKE_INSTALL_PREFIX})
set(bindir ${exec_prefix}/bin)

if(NOT DEFINED LIB_INSTALL_DIR)
    set(LIB_INSTALL_DIR "${exec_prefix}/lib" CACHE PATH "Library install directory [default=PREFIX/lib/]")
endif()
if(NOT DEFINED LIBDATA_INSTALL_DIR)
    set(LIBDATA_INSTALL_DIR "${LIB_INSTALL_DIR}"  CACHE PATH "Lib data install directory [default=LIB_INSTALL_DIR]")
endif()
if(NOT DEFINED MAN_INSTALL_DIR)
    set(MAN_INSTALL_DIR "${prefix}/share/man"  CACHE PATH "man install directory [default=PREFIX/share/man]")
endif()
if (NOT DEFINED DBUS_SERVICE_DIR)
    set(DBUS_SERVICE_DIR "${CMAKE_INSTALL_PREFIX}/share/dbus-1/services" CACHE PATH "dbus session service directory [default=PREFIX/share/dbus-1/services]")
endif()
if (NOT DEFINED SYSCONFDIR)
    set(SYSCONFDIR "${CMAKE_INSTALL_PREFIX}/etc" CACHE PATH "sys config directory [default=PREFIX/etc/]")
endif()

set(includedir "${CMAKE_INSTALL_PREFIX}/include")
set(libdir ${LIB_INSTALL_DIR})
set(pkgconfdir ${LIBDATA_INSTALL_DIR}/pkgconfig)
set(mandir ${MAN_INSTALL_DIR})
set(addondir ${libdir}/${package} )
set(pkgdatadir ${prefix}/share/${package})
set(configdescdir ${pkgdatadir}/configdesc)
set(addonconfigdir ${pkgdatadir}/addon)
set(imconfigdir ${pkgdatadir}/inputmethod)
set(localedir ${CMAKE_INSTALL_PREFIX}/share/locale)

list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${LIB_INSTALL_DIR}" _isSystemPlatformLibDir)
list(FIND CMAKE_CXX_IMPLICIT_LINK_DIRECTORIES "${LIB_INSTALL_DIR}" _isSystemCxxLibDir)

# For FcitxMacro
set(FCITX4_ADDON_INSTALL_DIR ${addondir})
set(FCITX4_CONFIGDESC_INSTALL_DIR ${configdescdir})
set(FCITX4_ADDON_CONFIG_INSTALL_DIR ${addonconfigdir})
set(FCITX4_INPUTMETHOD_CONFIG_INSTALL_DIR ${imconfigdir})
set(FCITX4_PACKAGE_NAME ${package})

function(_RESOLVE_LIBRARY_PATH _FILE_NAME _LIBRARY_PATH)
    if (CMAKE_OBJDUMP)
        execute_process (
            COMMAND ${CMAKE_OBJDUMP} -p "${_LIBRARY_PATH}"
            RESULT_VARIABLE STATUS
            OUTPUT_VARIABLE OBJDUMP_RESULT
            ERROR_QUIET
        )
        string(REGEX REPLACE ".*SONAME +([^ ]+)\n.*$" "\\1" SONAME_OUT "${OBJDUMP_RESULT}")
        if (SONAME_OUT)
            set(_FILE_NAME_OUT "${SONAME_OUT}")
        endif ()
    endif()
    if (NOT _FILE_NAME_OUT)
        get_filename_component(_FILE_NAME_OUT "${_LIBRARY_PATH}" NAME)
    endif()
    set(${_FILE_NAME} ${_FILE_NAME_OUT} PARENT_SCOPE)
endfunction()


if (NOT DEFINED OPENCC_LIBRARY_FILENAME)
    if (OPENCC_LIBRARIES)
        _RESOLVE_LIBRARY_PATH(OPENCC_LIBRARY_FILENAME "${OPENCC_LIBRARIES}")
    else ()
        set(OPENCC_LIBRARY_FILENAME
            "${CMAKE_SHARED_LIBRARY_PREFIX}opencc${CMAKE_SHARED_LIBRARY_SUFFIX}")
    endif ()
endif()

if(NOT DEFINED ENCHANT_LIBRARY_FILENAME)
    if (ENCHANT_LIBRARIES)
        _RESOLVE_LIBRARY_PATH(ENCHANT_LIBRARY_FILENAME "${ENCHANT_LIBRARIES}")
    else ()
        set(ENCHANT_LIBRARY_FILENAME
            "${CMAKE_SHARED_LIBRARY_PREFIX}enchant${CMAKE_SHARED_LIBRARY_SUFFIX}")
    endif ()
endif()
if(NOT DEFINED PRESAGE_LIBRARY_FILENAME)
    if (PRESAGE_LIBRARIES)
        _RESOLVE_LIBRARY_PATH(PRESAGE_LIBRARY_FILENAME "${PRESAGE_LIBRARIES}")
    else ()
        set(PRESAGE_LIBRARY_FILENAME
            "${CMAKE_SHARED_LIBRARY_PREFIX}presage${CMAKE_SHARED_LIBRARY_SUFFIX}")
    endif ()
endif()

set(CMAKE_C_FLAGS "-Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -fvisibility=hidden ${CMAKE_C_FLAGS}")
set(CMAKE_CXX_FLAGS "-Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -fvisibility=hidden ${CMAKE_CXX_FLAGS}")
set(CMAKE_SHARED_LINKER_FLAGS "-Wl,--as-needed ${CMAKE_SHARED_LINKER_FLAGS}")
set(CMAKE_MODULE_LINKER_FLAGS "-Wl,--as-needed ${CMAKE_MODULE_LINKER_FLAGS}")
add_definitions("-D_GNU_SOURCE -DFCITX_HAVE_CONFIG_H")

configure_file(${PROJECT_SOURCE_DIR}/config.h.in ${PROJECT_BINARY_DIR}/config.h)
configure_file("${PROJECT_SOURCE_DIR}/cmake/FcitxConfigVersion.cmake.in"
               "${PROJECT_BINARY_DIR}/cmake/FcitxConfigVersion.cmake"
                IMMEDIATE @ONLY
)

include_directories(${PROJECT_BINARY_DIR})
include_directories(${PROJECT_BINARY_DIR}/src/)
include_directories(${PROJECT_SOURCE_DIR}/src/)
include_directories(${PROJECT_SOURCE_DIR}/src/lib/)

# must be the first
add_subdirectory(po)
add_subdirectory(src)
add_subdirectory(doc)
add_subdirectory(skin)
add_subdirectory(tools)
add_subdirectory(data)
add_subdirectory(cmake)

if(ENABLE_TEST)
  add_subdirectory(test)
endif()

=== src/module/vk/CMakeLists.txt ===
set(FCITX_VK_LINK_LIBS)
if(_ENABLE_CAIRO)
  include_directories(${CAIRO_XLIB_INCLUDE_DIRS})
  link_directories(${CAIRO_XLIB_LIBRARY_DIRS})
  set(FCITX_VK_LINK_LIBS ${FCITX_VK_LINK_LIBS}
    ${X11_LIBRARIES} ${CAIRO_XLIB_LIBRARIES})
  if(_ENABLE_PANGO)
    include_directories(${PANGOCAIRO_INCLUDE_DIRS})
    link_directories(${PANGOCAIRO_LIBRARY_DIRS})
    set(FCITX_VK_LINK_LIBS ${FCITX_VK_LINK_LIBS} ${PANGOCAIRO_LIBRARIES})
  else()
    include_directories(${FONTCONFIG_INCLUDE_DIRS})
    link_directories(${FONTCONFIG_LIBRARY_DIRS})
    set(FCITX_VK_LINK_LIBS ${FCITX_VK_LINK_LIBS} ${FONTCONFIG_LIBRARIES})
  endif()
  set(vk_noinstall)
else()
  set(vk_noinstall NO_INSTALL)
endif()

set(FCITX_VK_SOURCES
  vk.c
  ../../ui/cairostuff/cairostuff.c
  ../../ui/cairostuff/font.c
  )

fcitx_add_addon_full(vk ${vk_noinstall}
  SOURCES ${FCITX_VK_SOURCES}
  LINK_LIBS ${FCITX_VK_LINK_LIBS})

=== debian/changelog ===
fcitx (1:4.2.9.7-3mint1) ulyssa; urgency=medium

  * Tray icon: Use fcitx-kbd-symbolic instead of input-keyboard

 -- Clement Lefebvre <root@linuxmint.com>  Wed, 23 Dec 2020 12:39:16 +0000

=== debian/rules ===
#!/usr/bin/make -f

include debian/variables.mk
include debian/gencontrol.mk

%:
	dh $@ --with gir

override_dh_auto_clean: gen_control
	dh_auto_clean

override_dh_auto_configure: gen_control
	dh_auto_configure -- \
	    -DCMAKE_BUILD_TYPE=Release \
	    -DLIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
	    -DSYSCONFDIR=/etc \
	    -DENABLE_X11=ON \
	    -DENABLE_GLIB2=ON \
	    -DENABLE_CAIRO=ON \
	    -DENABLE_DBUS=ON \
	    -DENABLE_PANGO=ON \
	    -DENABLE_XKB=ON \
	    -DENABLE_DEBUG=OFF \
	    -DENABLE_PINYIN=ON \
	    -DENABLE_TABLE=ON \
	    -DENABLE_GTK2_IM_MODULE=ON \
	    -DENABLE_GTK3_IM_MODULE=ON \
	    -DENABLE_QT=OFF \
	    -DENABLE_LUA=ON \
	    -DENABLE_STATIC=OFF \
	    -DENABLE_TEST=ON \
	    -DENABLE_SNOOPER=ON \
	    -DENABLE_GIR=ON \
	    -DENABLE_ENCHANT=ON \
	    -DENABLE_PRESAGE=ON \
	    -DENABLE_ICU=ON \
	    -DENABLE_BACKTRACE=ON \
	    -DENABLE_XDGAUTOSTART=ON \
	    -DENABLE_GETTEXT=ON \
	    -DENCHANT_INCLUDE_DIR=/usr/share/enchant-2/ \
	    -DENCHANT_LIBRARIES=/usr/lib/$(DEB_HOST_MULTIARCH)/libenchant-2.so.2

override_dh_missing:
	dh_missing --fail-missing

override_dh_makeshlibs:
	dh_makeshlibs -plibfcitx-core0
	dh_makeshlibs -plibfcitx-config4
	dh_makeshlibs -plibfcitx-utils0
	dh_makeshlibs -plibfcitx-gclient1

## fcitx 4.2.9.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -213,6 +213,12 @@
 
 list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${LIB_INSTALL_DIR}" _isSystemPlatformLibDir)
 list(FIND CMAKE_CXX_IMPLICIT_LINK_DIRECTORIES "${LIB_INSTALL_DIR}" _isSystemCxxLibDir)
+if("${_isSystemPlatformLibDir}" STREQUAL "-1" AND "${_isSystemCxxLibDir}" STREQUAL "-1")
+    set(CMAKE_SKIP_BUILD_RPATH  FALSE)
+    set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
+    set(CMAKE_INSTALL_RPATH "${LIB_INSTALL_DIR}")
+    set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
+endif("${_isSystemPlatformLibDir}" STREQUAL "-1" AND "${_isSystemCxxLibDir}" STREQUAL "-1")
 
 # For FcitxMacro
 set(FCITX4_ADDON_INSTALL_DIR ${addondir})

=== data/CMakeLists.txt ===
add_subdirectory(script)
add_subdirectory(icon)

set(FCITX_DESC_FILES
  addon.desc
  config.desc
  profile.desc
  inputmethod.desc
  )

set(FCITX_DATA_FILES
  AutoEng.dat
  gbks2t.tab
  punc.mb.zh_CN
  punc.mb.zh_HK
  punc.mb.zh_TW
  vk.conf
  )

set(FCITX_DSEKTOP_FILES
  fcitx.desktop
  fcitx-configtool.desktop
  fcitx-autostart.desktop
  )

fcitx_translate_add_sources(
  fcitx-configtool.desktop.in
  fcitx.desktop.in
  fcitx-autostart.desktop.in)
fcitx_translate_add_apply_source(
  fcitx-configtool.desktop.in
  "${CMAKE_CURRENT_BINARY_DIR}/fcitx-configtool.desktop")
fcitx_translate_add_apply_source(
  fcitx.desktop.in
  "${CMAKE_CURRENT_BINARY_DIR}/fcitx.desktop")
fcitx_translate_add_apply_source(
  fcitx-autostart.desktop.in
  "${CMAKE_CURRENT_BINARY_DIR}/fcitx-autostart.desktop")

add_custom_target(desktopfile ALL DEPENDS ${FCITX_DSEKTOP_FILES})
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/fcitx.desktop"
  DESTINATION share/applications/)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/fcitx-configtool.desktop"
  DESTINATION share/applications/)

install(FILES ${FCITX_DATA_FILES} DESTINATION "${pkgdatadir}/data")
fcitx_install_addon_desc(${FCITX_DESC_FILES})

if(_ENABLE_DBUS AND ENABLE_XDGAUTOSTART)
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/fcitx-autostart.desktop"
    DESTINATION "${SYSCONFDIR}/xdg/autostart")
endif()

if(_ENABLE_DBUS)
  install(FILES daemon.conf DESTINATION share/fcitx/dbus/)
endif()

install(FILES env_setup.sh DESTINATION share/fcitx/data/)

=== tools/CMakeLists.txt ===
include_directories(../src/lib)

add_subdirectory(gui)
add_subdirectory(cli)
add_subdirectory(dev)

=== src/core/CMakeLists.txt ===
set(FCITX_SOURCES
  fcitx.c
  errorhandler.c
  )

add_executable(fcitx ${FCITX_SOURCES})
install(TARGETS fcitx RUNTIME DESTINATION "${bindir}")
target_link_libraries(fcitx fcitx-core ${LIBEXECINFO_LIBRARIES})

fcitx_translate_add_sources(${FCITX_SOURCES} errorhandler.h)

=== src/frontend/qt/CMakeLists.txt ===
set(qtim_fcitx_SRCS
  qfcitxinputcontextplugin.cpp
  qfcitxinputcontext.cpp
  qtkey.cpp
  fcitxwatcher.cpp
  fcitxinputcontextproxy.cpp
  fcitxqtdbustypes.cpp
  )

fcitx_translate_add_sources(${qtim_fcitx_SRCS}
  qfcitxinputcontext.h
  )

if(NOT (ENABLE_QT_IM_MODULE AND ENABLE_QT))
  return()
endif()

set_source_files_properties(org.fcitx.Fcitx.InputContext.xml PROPERTIES
INCLUDE fcitxqtdbustypes.h)
set_source_files_properties(org.fcitx.Fcitx.InputContext1.xml PROPERTIES
INCLUDE fcitxqtdbustypes.h)
set_source_files_properties(org.fcitx.Fcitx.InputMethod.xml PROPERTIES
INCLUDE fcitxqtdbustypes.h)
set_source_files_properties(org.fcitx.Fcitx.InputMethod1.xml PROPERTIES
INCLUDE fcitxqtdbustypes.h)

qt4_add_dbus_interface(qtim_fcitx_SRCS org.fcitx.Fcitx.InputContext.xml inputcontextproxy)
qt4_add_dbus_interface(qtim_fcitx_SRCS org.fcitx.Fcitx.InputContext1.xml inputcontext1proxy)
qt4_add_dbus_interface(qtim_fcitx_SRCS org.fcitx.Fcitx.InputMethod.xml inputmethodproxy)
qt4_add_dbus_interface(qtim_fcitx_SRCS org.fcitx.Fcitx.InputMethod1.xml inputmethod1proxy)

include_directories(
  ${QT_INCLUDE_DIR}
  ${QT_QTCORE_INCLUDE_DIR}
  ${QT_QTGUI_INCLUDE_DIR}
  ${QT_QTDBUS_INCLUDE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}
  )

if(ENABLE_X11)
  include_directories(${X11_INCLUDE_DIRS})
  link_directories(${X11_LIBRARY_DIRS})
endif()

add_library(
  qtim-fcitx MODULE
  ${qtim_fcitx_SRCS}
  )

set_target_properties(qtim-fcitx PROPERTIES
  PREFIX ""
  COMPILE_FLAGS "-fvisibility=hidden"
  LINK_FLAGS "-Wl,--no-undefined"
  CXX_STANDARD 11
  AUTOMOC TRUE)

target_link_libraries(
  qtim-fcitx
  debug ${QT_QTCORE_LIBRARY_DEBUG}
  debug ${QT_QTDBUS_LIBRARY_DEBUG}
  debug ${QT_QTGUI_LIBRARY_DEBUG}
  optimized ${QT_QTCORE_LIBRARY_RELEASE}
  optimized ${QT_QTDBUS_LIBRARY_RELEASE}
  optimized ${QT_QTGUI_LIBRARY_RELEASE}
  XKBCommon::XKBCommon
  )

if(ENABLE_X11)
  target_link_libraries(qtim-fcitx ${X11_LIBRARIES})
endif()

install(
  TARGETS qtim-fcitx
  LIBRARY DESTINATION
  "${QT_PLUGINS_DIR}/inputmethods")

=== src/lib/fcitx-utils/CMakeLists.txt ===
set(FCITX_UTILS_SOURCES
  utf8.c
  utils.c
  log.c
  qsort_r.c
  msort_r.c
  memory.c
  handler-table.c
  objpool.c
  desktop-parse.c
  stringmap.c
  )

set(FCITX_UTILS_HEADERS
  log.h
  utarray.h
  utf8.h
  utils.h
  uthash.h
  memory.h
  keysym.h
  keysymgen.h
  bitset.h
  handler-table.h
  objpool.h
  desktop-parse.h
  stringmap.h
  )

fcitx_translate_add_sources(${FCITX_UTILS_SOURCES} ${FCITX_UTILS_HEADERS})

if(LIBKVM_FOUND)
  include_directories(LIBKVM_INCLUDE_DIR)
endif()

add_library(fcitx-utils SHARED ${FCITX_UTILS_SOURCES})
set_target_properties(fcitx-utils
  PROPERTIES VERSION 0.1
  SOVERSION 0
  COMPILE_FLAGS "-fvisibility=hidden"
  LINK_FLAGS "-Wl,--no-undefined"
  )
target_link_libraries(fcitx-utils ${LIBINTL_LIBRARIES}
  ${LIBICONV_LIBRARIES} ${LIBEXECINFO_LIBRARIES})

if(LIBKVM_FOUND)
  target_link_libraries(fcitx-utils ${LIBKVM_LIBRARIES})
endif()

configure_file(fcitx-utils.pc.in ${CMAKE_CURRENT_BINARY_DIR}/fcitx-utils.pc)

install(TARGETS fcitx-utils LIBRARY DESTINATION "${libdir}")
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/fcitx-utils.pc
  DESTINATION "${pkgconfdir}")
install(FILES ${FCITX_UTILS_HEADERS} DESTINATION "${includedir}/fcitx-utils")

if(ENABLE_STATIC)
  add_library(fcitx-utils-static STATIC ${FCITX_UTILS_SOURCES})
  set_target_properties(fcitx-utils-static PROPERTIES
    OUTPUT_NAME "fcitx-utils"
    PREFIX "lib")
  install(TARGETS fcitx-utils-static
    LIBRARY DESTINATION ${libdir}
    ARCHIVE DESTINATION ${libdir})
endif()

=== src/lib/fcitx/CMakeLists.txt ===
set(LIBFCITX_SOURCES
  instance.c
  candidate.c
  configfile.c
  profile.c
  addon.c
  frontend.c
  hook.c
  ime.c
  ui.c
  module.c
  keys.c
  context.c
  )

set(FCITX_HEADERS
  candidate.h
  ime.h
  ui.h
  hook.h
  configfile.h
  profile.h
  module.h
  instance.h
  addon.h
  frontend.h
  fcitx.h
  keys.h
  context.h
  )

set(FCITX_INTERNAL_HEADERS
  addon-internal.h
  context-internal.h
  fcitx-internal.h
  hook-internal.h
  ime-internal.h
  instance-internal.h
  module-internal.h
  ui-internal.h
  )

fcitx_translate_add_sources(${LIBFCITX_SOURCES} ${FCITX_HEADERS}
  ${FCITX_INTERNAL_HEADERS})

link_directories(${DL_LIBRARY_DIRS} ${PTHREAD_LIBRARY_DIRS})

add_library(fcitx-core SHARED ${LIBFCITX_SOURCES})
set_target_properties(fcitx-core
  PROPERTIES VERSION 0.3
  SOVERSION 0
  COMPILE_FLAGS "-fvisibility=hidden"
  LINK_FLAGS "-Wl,--no-undefined")

configure_file(fcitx.pc.in ${CMAKE_CURRENT_BINARY_DIR}/fcitx.pc)

target_link_libraries(fcitx-core fcitx-config fcitx-utils
  ${DL_LIBRARIES} ${PTHREAD_LIBRARIES})
install(TARGETS fcitx-core LIBRARY DESTINATION "${libdir}")
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/fcitx.pc
  DESTINATION "${pkgconfdir}")
install(FILES ${FCITX_HEADERS} DESTINATION "${includedir}/fcitx")

if(ENABLE_STATIC)
  add_library(fcitx-core-static STATIC ${LIBFCITX_SOURCES})
  set_target_properties(fcitx-core-static PROPERTIES
    OUTPUT_NAME "fcitx-core"
    PREFIX "lib")

  install(TARGETS fcitx-core-static
    LIBRARY DESTINATION "${libdir}"
    ARCHIVE DESTINATION "${libdir}")
endif()

=== src/module/dbus/CMakeLists.txt ===
set(FCITX_DBUS_LINK_LIBS)
if(_ENABLE_DBUS)
  include_directories(${DBUS_INCLUDE_DIRS})
  link_directories(${DBUS_LIBRARY_DIRS})
  set(FCITX_DBUS_LINK_LIBS ${FCITX_DBUS_LINK_LIBS}
    ${DBUS_LIBRARIES})
  set(dbus_noinstall)
else()
  set(dbus_noinstall NO_INSTALL)
endif()

set(FCITX_DBUS_SOURCES
  dbussocket.c
  dbusstuff.c
  dbuslauncher.c
  )

fcitx_add_addon_full(dbus SCAN SCAN_PRIV ${dbus_noinstall}
  SOURCES ${FCITX_DBUS_SOURCES}
  HEADERS dbusstuff.h
  LINK_LIBS ${FCITX_DBUS_LINK_LIBS})

set(FCITX_DBUS_WATCHER_SOURCES
  dbussocket.c
  watcher.c
  )
set(FCITX_DBUS_REMOTE_SOURCES
  dbusremote.c
  )

fcitx_translate_add_sources(${FCITX_DBUS_REMOTE_SOURCES}
  ${FCITX_DBUS_WATCHER_SOURCES})

if(_ENABLE_DBUS)
  add_executable(fcitx-dbus-watcher ${FCITX_DBUS_WATCHER_SOURCES})
  target_link_libraries(fcitx-dbus-watcher ${DBUS_LIBRARIES} fcitx-utils)
  install(TARGETS fcitx-dbus-watcher DESTINATION "${bindir}")
  add_executable(fcitx-dbus-remote ${FCITX_DBUS_REMOTE_SOURCES})
  set_target_properties(fcitx-dbus-remote PROPERTIES OUTPUT_NAME fcitx-remote)
  target_link_libraries(fcitx-dbus-remote ${DBUS_LIBRARIES}
    fcitx-config fcitx-utils)
  install(TARGETS fcitx-dbus-remote DESTINATION "${bindir}")
  configure_file("${CMAKE_CURRENT_SOURCE_DIR}/org.fcitx.Fcitx.service.in" "${CMAKE_CURRENT_BINARY_DIR}/org.fcitx.Fcitx.service" @ONLY)
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/org.fcitx.Fcitx.service" DESTINATION "${DBUS_SERVICE_DIR}")
endif()

=== src/module/pinyin-enhance/CMakeLists.txt ===
if (ENABLE_PINYIN)
    set(pinyin_noinstall)
    add_subdirectory(data)
else()
    set(pinyin_noinstall NO_INSTALL)
endif()


set(FCITX_PYENHANCE_SOURCES
  pinyin-enhance.c
  pinyin-enhance-spell.c
  pinyin-enhance-cfp.c
  pinyin-enhance-map.c
  pinyin-enhance-stroke.c
  pinyin-enhance-py.c
  pinyin-enhance-sym.c)

fcitx_add_addon_full(pinyin-enhance DESC SCAN SCAN_PRIV
  HEADERS pinyin-enhance.h
  SOURCES ${FCITX_PYENHANCE_SOURCES}
  ${pinyin_noinstall})

=== src/module/quickphrase/CMakeLists.txt ===
set(FCITX_QUICKPHRASE_SOURCES
  quickphrase.c)

fcitx_add_addon_full(quickphrase SCAN SCAN_PRIV DESC
  SOURCES ${FCITX_QUICKPHRASE_SOURCES}
  HEADERS quickphrase.h)

install(DIRECTORY quickphrase.d DESTINATION "${pkgdatadir}/data"
  FILES_MATCHING PATTERN "*.mb")

=== src/module/unicode/CMakeLists.txt ===
set(FCITX_UNICODE_SOURCES
  unicode.c
  charselectdata.c)

fcitx_add_addon_full(unicode DESC
  SOURCES ${FCITX_UNICODE_SOURCES})

install(FILES charselectdata DESTINATION ${pkgdatadir}/data/)

=== src/module/x11/CMakeLists.txt ===
set(FCITX_X11_LINK_LIBS)
if(ENABLE_X11)
  include_directories(${X11_X11_INCLUDE_PATH})
  set(FCITX_X11_LINK_LIBS ${FCITX_X11_LINK_LIBS}
    ${X11_LIBRARIES} ${X11_Xrender_LIB})
  if(HAVE_XINERAMA)
    set(FCITX_X11_LINK_LIBS ${FCITX_X11_LINK_LIBS} ${X11_Xinerama_LIB})
  endif()
  if(HAVE_XFIXES)
    set(FCITX_X11_LINK_LIBS ${FCITX_X11_LINK_LIBS} ${X11_Xfixes_LIB})
  endif(HAVE_XFIXES)
  set(x11_noinstall)
else()
  set(x11_noinstall NO_INSTALL)
endif()

set(FCITX_X11_SOURCES
  xerrorhandler.c
  x11stuff.c
  x11selection.c)
fcitx_add_addon_full(x11 SCAN_IN SCAN_PRIV ${x11_noinstall}
  SOURCES ${FCITX_X11_SOURCES}
  HEADERS x11stuff.h
  LINK_LIBS ${FCITX_X11_LINK_LIBS}
  EXTRA_PO xerrorhandler.h)

=== debian/changelog ===
fcitx (1:4.2.9.8-1) unstable; urgency=medium

  * Team upload.
  * New upstream maintenance release 4.2.9.8.

 -- Boyuan Yang <byang@debian.org>  Wed, 05 Aug 2020 13:36:50 -0400

fcitx (1:4.2.9.7-4) unstable; urgency=medium

  * Team upload.
  * Rebuild to rule out any possible binary incompatibilities.
  * debian/control:
    + Bump Standards-Version to 4.5.0.
    + Bump debhelper compat to v13.
  * debian/patches/0004: Properly detect enchant-2. (Closes: #956704)

 -- Boyuan Yang <byang@debian.org>  Tue, 12 May 2020 11:17:17 -0400

=== debian/control ===
# debian/control is generated automatically from control.in by running the clean target
Source: fcitx
Section: utils
Priority: optional
Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
Uploaders: Aron Xu <aron@debian.org>, YunQiang Su <syq@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               extra-cmake-modules,
               gobject-introspection,
               iso-codes,
               qtbase5-dev,
               libcairo2-dev (>= 1.0),
               libenchant-2-dev,
               libgettextpo-dev,
               libgirepository1.0-dev,
               libgtk-3-dev,
               libgtk2.0-dev,
               libicu-dev,
               libjson-c-dev,
               libkvm-dev [kfreebsd-any],
               liblua5.2-dev | liblua5.1-0-dev,
               libopencc-dev (>= 1.0.1),
               libpango1.0-dev (>= 1.0),
               libpresage-dev (>= 0.9.1-1.1~),
               libxkbfile-dev,
               libxkbcommon-dev (>= 0.5.0~),
               libxml2-dev,
               uuid-dev,
               x11proto-xinerama-dev,
Rules-Requires-Root: no
Standards-Version: 4.5.0
Homepage: https://github.com/fcitx/fcitx
Vcs-Git: https://salsa.debian.org/input-method-team/fcitx.git
Vcs-Browser: https://salsa.debian.org/input-method-team/fcitx
X-Ubuntu-Use-Langpack: yes

Package: fcitx
Architecture: all
Depends: fcitx-bin, fcitx-data, fcitx-modules, ${misc:Depends}
Recommends: fcitx-config-gtk | kde-config-fcitx,
            fcitx-frontend-all | fcitx-frontend-fbterm,
            fcitx-ui-classic | fcitx-ui-light,
            im-config (>= 0.5)
Suggests: fcitx-m17n, fcitx-tools
Description: Flexible Input Method Framework
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems.
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt5 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This metapackage pulls in a set of components recommended for most desktop
 users.

Package: fcitx-bin
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: fcitx-data, fcitx-modules
Suggests: fcitx (>= ${source:Upstream-Version})
Replaces:
 fcitx (<< ${source:Upstream-Version}),
 fcitx-libs-dev (<< ${source:Version}),
Breaks:
 fcitx (<< ${source:Upstream-Version}),
 fcitx-libs-dev (<< ${source:Version}),
Description: Flexible Input Method Framework - essential binaries
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems.
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt5 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the essential executable binaries. If you are
 looking for a working input experience, please install the package
 "fcitx" instead.

Package: fcitx-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: fcitx-bin
Suggests: fcitx (>= ${source:Upstream-Version})
Replaces: fcitx (<< ${source:Upstream-Version})
Breaks: fcitx (<< ${source:Upstream-Version})
Description: Flexible Input Method Framework - essential data files
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems.
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt5 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the essential data files. If you are looking for a
 working input experience, please install the package "fcitx" instead.

Package: fcitx-libs
Architecture: all
Section: oldlibs
Depends: libfcitx-config4 (>= ${source:Version}),
         libfcitx-core0 (>= ${source:Version}),
         libfcitx-utils0 (>= ${source:Version}),
         libfcitx-gclient1 (>= ${source:Version}),
         ${misc:Depends}
Suggests: fcitx (>= ${source:Upstream-Version})
Replaces: fcitx (<< ${source:Upstream-Version})
Breaks: fcitx (<< ${source:Upstream-Version})
Description: Flexible Input Method Framework - metapackage for libraries
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems.
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt5 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package depends on all public libraries of fcitx.

Package: libfcitx-config4
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: fcitx (>= ${source:Upstream-Version})
Replaces: fcitx (<< ${source:Upstream-Version}), fcitx-libs (<< 1:4.2.8.5-3)
Breaks: fcitx (<< ${source:Upstream-Version}), fcitx-libs (<< 1:4.2.8.5-3)
Description: Flexible Input Method Framework - configuration support library
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems.
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt5 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package contains the library file:
  * libfcitx-config - support library for Fcitx configurations

Package: libfcitx-core0
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: fcitx (>= ${source:Upstream-Version})
Replaces: fcitx (<< ${source:Upstream-Version}), fcitx-libs (<< 1:4.2.8.5-3)
Breaks: fcitx (<< ${source:Upstream-Version}), fcitx-libs (<< 1:4.2.8.5-3)
Description: Flexible Input Method Framework - library of core functions
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems.
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt5 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package contains the library file:
  * libfcitx-core - core functions of Fcitx

Package: libfcitx-utils0
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: fcitx (>= ${source:Upstream-Version})
Replaces: fcitx (<< ${source:Upstream-Version}), fcitx-libs (<< 1:4.2.8.5-3)
Breaks: fcitx (<< ${source:Upstream-Version}), fcitx-libs (<< 1:4.2.8.5-3)
Description: Flexible Input Method Framework - utility support library
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems.
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt5 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package contains the library file:
  * libfcitx-utils - utility support library for Fcitx

Package: libfcitx-gclient1
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: fcitx (>= ${source:Upstream-Version})
Replaces: fcitx (<< ${source:Upstream-Version}),
          fcitx-libs-gclient (<< 1:4.2.8.5-3)
Breaks: fcitx (<< ${source:Upstream-Version}),
        fcitx-libs-gclient (<< 1:4.2.8.5-3)
Description: Flexible Input Method Framework - D-Bus client library for Glib
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems.
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt5 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package contains the following library:
  * libfcitx-gclient - D-Bus client library for Glib

Package: fcitx-libs-dev
Architecture: any
Section: libdevel
Depends: fcitx-bin (>= ${source:Version}),
         gir1.2-fcitx-1.0 (= ${binary:Version}),
         libfcitx-config4 (= ${binary:Version}),
         libfcitx-core0 (= ${binary:Version}),
         libfcitx-gclient1 (= ${binary:Version}),
         libfcitx-utils0 (= ${binary:Version}),
         ${misc:Depends}
Replaces: fcitx (<< ${source:Upstream-Version})
Breaks: fcitx (<< ${source:Upstream-Version})
Description: Flexible Input Method Framework - library development files
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems.
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt5 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the library development files.

Package: gir1.2-fcitx-1.0
Architecture: any
Section: introspection
Depends: ${gir:Depends}, ${misc:Depends}
Suggests: fcitx (>= ${source:Upstream-Version})
Replaces: fcitx (<< ${source:Upstream-Version})
Breaks: fcitx (<< ${source:Upstream-Version})
Description: GObject introspection data for fcitx
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems.
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt5 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package can be used by other packages using the GIRepository format to
 generate dynamic bindings.

Package: fcitx-ui-classic
Architecture: any
Depends: fcitx-module-x11, ${misc:Depends}, ${shlibs:Depends}
Recommends: fcitx (>= ${source:Upstream-Version}), zenity | kdialog
Replaces: fcitx (<< ${source:Upstream-Version}),
          fcitx-hangul (<< 0.3.0),
          fcitx-unikey (<< 0.2.0)
Breaks: fcitx (<< ${source:Upstream-Version}),
        fcitx-hangul (<< 0.3.0),
        fcitx-unikey (<< 0.2.0)
Description: Flexible Input Method Framework - Classic user interface
 Fcitx is a input method framework with extension support, which provides

=== debian/rules ===
--- 
+++ 
@@ -40,9 +40,6 @@
 	    -DENCHANT_INCLUDE_DIR=/usr/share/enchant-2/ \
 	    -DENCHANT_LIBRARIES=/usr/lib/$(DEB_HOST_MULTIARCH)/libenchant-2.so.2
 
-override_dh_missing:
-	dh_missing --fail-missing
-
 override_dh_makeshlibs:
 	dh_makeshlibs -plibfcitx-core0
 	dh_makeshlibs -plibfcitx-config4

## fcitx 4.2.9.8+mint1+elsie

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 project(fcitx)
 
-set(version 4.2.9.7)
+set(version 4.2.9.8)
 
 set(CMAKE_C_STANDARD 99)
 set(CMAKE_C_STANDARD_REQUIRED TRUE)
@@ -213,12 +213,6 @@
 
 list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${LIB_INSTALL_DIR}" _isSystemPlatformLibDir)
 list(FIND CMAKE_CXX_IMPLICIT_LINK_DIRECTORIES "${LIB_INSTALL_DIR}" _isSystemCxxLibDir)
-if("${_isSystemPlatformLibDir}" STREQUAL "-1" AND "${_isSystemCxxLibDir}" STREQUAL "-1")
-    set(CMAKE_SKIP_BUILD_RPATH  FALSE)
-    set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
-    set(CMAKE_INSTALL_RPATH "${LIB_INSTALL_DIR}")
-    set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
-endif("${_isSystemPlatformLibDir}" STREQUAL "-1" AND "${_isSystemCxxLibDir}" STREQUAL "-1")
 
 # For FcitxMacro
 set(FCITX4_ADDON_INSTALL_DIR ${addondir})

=== debian/changelog ===
fcitx (1:4.2.9.8+mint1+elsie) elsie; urgency=medium

  * Tray icon: Use fcitx-kbd-symbolic instead of input-keyboard

 -- Clement Lefebvre <root@linuxmint.com>  Wed, 26 Jan 2022 09:59:55 +0000

fcitx (1:4.2.9.8-3) unstable; urgency=medium

  * Team upload.
  * debian/control: Recommend package dbus-x11 when installing
    package fcitx-module-dbus. (Closes: #971436)

  [ Aron Xu ]
  * debian/control: Fix typo in package description, thanks to
    sabrina@culturesky.

 -- Boyuan Yang <byang@debian.org>  Fri, 22 Jan 2021 19:12:44 -0500

fcitx (1:4.2.9.8-2) unstable; urgency=medium

  * Team upload.
  * Rebuild before Debian 11 release.
  * Backport upstream trunk patches till 2021-01-03.
  * debian/control: Bump Standards-Version to 4.5.1.
  * debian/rules: Drop custom enchant-2 workaround.
  * debian/copyright: Fix broken path.
  * debian/fcitx-bin.lintian-overrides: Update override name.
  * debian/libfcitx-core0.symbols: Add build-depends-package field.

 -- Boyuan Yang <byang@debian.org>  Fri, 22 Jan 2021 18:39:29 -0500

## fcitx 4.2.9.8+mint1+vanessa

=== src/im/CMakeLists.txt ===
add_subdirectory(pinyin)
add_subdirectory(keyboard)
add_subdirectory(table)
add_subdirectory(qw)

=== src/frontend/xim/CMakeLists.txt ===
set(FCITX_XIM_LINK_LIBS)
if(ENABLE_X11)
  include_directories(lib ${X11_X11_INCLUDE_PATH})
  set(FCITX_XIM_LINK_LIBS ${FCITX_XIM_LINK_LIBS} ${X11_LIBRARIES})
  set(xim_noinstall)
else()
  set(xim_noinstall NO_INSTALL)
endif()

set(FCITX_XIM_SOURCES
  IC.c
  xim.c
  ximhandler.c
  ximconfig.c
  ximqueue.c
  )

set(Ximd_SOURCES
  lib/FrameMgr.c
  lib/i18nAttr.c
  lib/i18nClbk.c
  lib/i18nIc.c
  lib/i18nIMProto.c
  lib/i18nMethod.c
  lib/i18nPtHdr.c
  lib/i18nUtil.c
  lib/i18nX.c
  lib/IMConn.c
  lib/IMMethod.c
  lib/IMValues.c
  )

set(Ximd_HEADERS
  lib/IMdkit.h
  lib/Xi18nX.h
  lib/Xi18n.h
  lib/FrameMgr.h
  lib/Xi18nTr.h
  lib/XimFunc.h
  lib/XimProto.h
  )

set(FCITX_XIM_HEADERS
  IC.h
  xim.h
  ximhandler.h
  ximqueue.h
  )

fcitx_add_addon_full(xim DESC SCAN SCAN_PRIV SCAN_NO_INSTALL ${xim_noinstall}
  SOURCES ${FCITX_XIM_SOURCES} ${Ximd_SOURCES}
  LINK_LIBS ${FCITX_XIM_LINK_LIBS}
  EXTRA_PO ${FCITX_XIM_HEADERS} ${Ximd_HEADERS})

=== debian/changelog ===
fcitx (1:4.2.9.8+mint1+vanessa) vanessa; urgency=medium

  * Native source format
  * Tray icon: Use fcitx-kbd-symbolic instead of input-keyboard

 -- Clement Lefebvre <root@linuxmint.com>  Tue, 10 May 2022 15:40:13 +0100

fcitx (1:4.2.9.8-5) unstable; urgency=medium

  * Team upload.
  * debian/control: Clean up the quickphrase editor mess: (#964189)
    + Use the latest package name fcitx-module-quickphrase-editor5.
    + Break/Replace with old fcitx5-module-quickphrase-editor.

 -- Boyuan Yang <byang@debian.org>  Thu, 03 Feb 2022 15:08:09 -0500

fcitx (1:4.2.9.8-4) unstable; urgency=medium

  * Team upload.
  * debian/control: Bump Standards-Version to 4.6.0.
  * debian/variables.mk: Drop --as-needed linker flag,
    no longer needed.
  * debian/control: Let fcitx{,-data,-bin} conflict with fcitx5.
    (See #976603)

 -- Boyuan Yang <byang@debian.org>  Tue, 23 Nov 2021 13:19:57 -0500

=== debian/control ===
--- 
+++ 
@@ -29,7 +29,7 @@
                uuid-dev,
                x11proto-xinerama-dev,
 Rules-Requires-Root: no
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Homepage: https://github.com/fcitx/fcitx
 Vcs-Git: https://salsa.debian.org/input-method-team/fcitx.git
 Vcs-Browser: https://salsa.debian.org/input-method-team/fcitx
@@ -43,8 +43,9 @@
             fcitx-ui-classic | fcitx-ui-light,
             im-config (>= 0.5)
 Suggests: fcitx-m17n, fcitx-tools
+Conflicts: fcitx5
 Description: Flexible Input Method Framework
- Fcitx is a input method framework with extension support, which provides
+ Fcitx is an input method framework with extension support, which provides
  an interface for entering characters of different scripts in applications
  using a variety of mapping systems.
  .
@@ -68,8 +69,10 @@
 Breaks:
  fcitx (<< ${source:Upstream-Version}),
  fcitx-libs-dev (<< ${source:Version}),
+Conflicts:
+ fcitx5,
 Description: Flexible Input Method Framework - essential binaries
- Fcitx is a input method framework with extension support, which provides
+ Fcitx is an input method framework with extension support, which provides
  an interface for entering characters of different scripts in applications
  using a variety of mapping systems.
  .
@@ -91,8 +94,9 @@
 Suggests: fcitx (>= ${source:Upstream-Version})
 Replaces: fcitx (<< ${source:Upstream-Version})
 Breaks: fcitx (<< ${source:Upstream-Version})
+Conflicts: fcitx5
 Description: Flexible Input Method Framework - essential data files
- Fcitx is a input method framework with extension support, which provides
+ Fcitx is an input method framework with extension support, which provides
  an interface for entering characters of different scripts in applications
  using a variety of mapping systems.
  .
@@ -117,7 +121,7 @@
 Replaces: fcitx (<< ${source:Upstream-Version})
 Breaks: fcitx (<< ${source:Upstream-Version})
 Description: Flexible Input Method Framework - metapackage for libraries
- Fcitx is a input method framework with extension support, which provides
+ Fcitx is an input method framework with extension support, which provides
  an interface for entering characters of different scripts in applications
  using a variety of mapping systems.
  .
@@ -139,7 +143,7 @@
 Replaces: fcitx (<< ${source:Upstream-Version}), fcitx-libs (<< 1:4.2.8.5-3)
 Breaks: fcitx (<< ${source:Upstream-Version}), fcitx-libs (<< 1:4.2.8.5-3)
 Description: Flexible Input Method Framework - configuration support library
- Fcitx is a input method framework with extension support, which provides
+ Fcitx is an input method framework with extension support, which provides
  an interface for entering characters of different scripts in applications
  using a variety of mapping systems.
  .
@@ -162,7 +166,7 @@
 Replaces: fcitx (<< ${source:Upstream-Version}), fcitx-libs (<< 1:4.2.8.5-3)
 Breaks: fcitx (<< ${source:Upstream-Version}), fcitx-libs (<< 1:4.2.8.5-3)
 Description: Flexible Input Method Framework - library of core functions
- Fcitx is a input method framework with extension support, which provides
+ Fcitx is an input method framework with extension support, which provides
  an interface for entering characters of different scripts in applications
  using a variety of mapping systems.
  .
@@ -185,7 +189,7 @@
 Replaces: fcitx (<< ${source:Upstream-Version}), fcitx-libs (<< 1:4.2.8.5-3)
 Breaks: fcitx (<< ${source:Upstream-Version}), fcitx-libs (<< 1:4.2.8.5-3)
 Description: Flexible Input Method Framework - utility support library
- Fcitx is a input method framework with extension support, which provides
+ Fcitx is an input method framework with extension support, which provides
  an interface for entering characters of different scripts in applications
  using a variety of mapping systems.
  .
@@ -210,7 +214,7 @@
 Breaks: fcitx (<< ${source:Upstream-Version}),
         fcitx-libs-gclient (<< 1:4.2.8.5-3)
 Description: Flexible Input Method Framework - D-Bus client library for Glib
- Fcitx is a input method framework with extension support, which provides
+ Fcitx is an input method framework with extension support, which provides
  an interface for entering characters of different scripts in applications
  using a variety of mapping systems.
  .
@@ -236,7 +240,7 @@
 Replaces: fcitx (<< ${source:Upstream-Version})
 Breaks: fcitx (<< ${source:Upstream-Version})
 Description: Flexible Input Method Framework - library development files
- Fcitx is a input method framework with extension support, which provides
+ Fcitx is an input method framework with extension support, which provides
  an interface for entering characters of different scripts in applications
  using a variety of mapping systems.
  .
@@ -256,7 +260,7 @@
 Replaces: fcitx (<< ${source:Upstream-Version})
 Breaks: fcitx (<< ${source:Upstream-Version})
 Description: GObject introspection data for fcitx
- Fcitx is a input method framework with extension support, which provides
+ Fcitx is an input method framework with extension support, which provides
  an interface for entering characters of different scripts in applications
  using a variety of mapping systems.
  .
@@ -280,4 +284,3 @@
         fcitx-hangul (<< 0.3.0),
         fcitx-unikey (<< 0.2.0)
 Description: Flexible Input Method Framework - Classic user interface
- Fcitx is a input method framework with extension support, which provides
